---
swagger: "2.0"
info:
  title: Currency Microservice
  description: For external stakeholders to query which countries currently use an ISO 4217 formatted currency code and additionally, which countries share a physical border with those countries but which do not share the provided currency code.
  version: 2.2.3
host: localhost
basePath: /api/
schemes:
  - https
produces:
  - application/json
paths:
  /borderInfo:
    get:
      summary: An API to query which countries use the provided ISO 4217 formatted currency code.
      description: returns a JSON object containing 2 lists. 1st list is named 'supportedCountryCodes' and contains the country codes which use the provided currency code. 2nd list is named 'borderCountryCodes' and contains the country codes for the countries who share physical borders with those in the first list but which do not share the provided currency code. Both lists of country codes are formatted in ISO 3166-1 format, example 'GB'
      parameters:
        - in: query
          name: currency
          type: string
          pattern: '^[a-zA-Z]{2,3}$'
          description: ISO 4217 formatted currency code, example 'GBP'
      responses:
        200:
          description: OK
          schema:
            $ref: '#/definitions/CountryDTO'
        400:
          description: Bad request, currency parameter must be a string of 2 - 3 letters.
        404:
          description: Provided currency code not found.
        503:
          description: Service unavailable.
definitions:
  CountryDTO:
    properties:
      supportedCountryCodes:
        type: array
        items:
          type: string
      borderCountryCodes:
        type: array
        items:
          type: string
